----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:53:01 04/08/2015 
-- Design Name: 
-- Module Name:    round - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity round is
	port (
		rk			: in std_logic_vector(31 downto 0);
		round_i	: in std_logic_vector(63 downto 0);
		round_o	: out std_logic_vector(63 downto 0)
	);
end round;

architecture Behavioral of round is

	component sbox is
		port(
			nibble_in : in std_logic_vector(3 downto 0);
			nibble_out: out std_logic_vector(3 downto 0)
		);
	end component;
	
	signal sbox_in, sbox_out	: std_logic_vector(31 downto 0);

begin

  sbox_in <= round_i(31 downto 0) xor rk;
	
  sbox_0 : sbox port map (
    nibble_in	=>	sbox_in(31 downto 28),
    nibble_out	=> sbox_out(3 downto 0)
  );
  
  sbox_1 : sbox port map (
    nibble_in	=>	sbox_in(27 downto 24),
    nibble_out	=> sbox_out(7 downto 4)
  );
  
  sbox_2 : sbox port map (
    nibble_in	=>	sbox_in(23 downto 20),
    nibble_out	=> sbox_out(11 downto 8)
  );
  
  sbox_3 : sbox port map (
    nibble_in	=>	sbox_in(19 downto 16),
    nibble_out	=> sbox_out(15 downto 12)
  );
	
	sbox_4 : sbox port map (
    nibble_in	=>	sbox_in(15 downto 12),
    nibble_out	=> sbox_out(19 downto 16)
  );
  
  sbox_5 : sbox port map (
    nibble_in	=>	sbox_in(11 downto 8),
    nibble_out	=> sbox_out(23 downto 20)
  );
  
  sbox_6 : sbox port map (
    nibble_in	=>	sbox_in(7 downto 4),
    nibble_out	=> sbox_out(27 downto 24)
  );
  
  sbox_7 : sbox port map (
    nibble_in	=>	sbox_in(3 downto 0),
    nibble_out	=> sbox_out(31 downto 28)
  );
  
  round_o(31 downto 0) <= round_i(31 downto 0);
  
  round_o(35 downto 32) <= round_i(35 downto 32) xor sbox_out(3 downto 0);
  round_o(39 downto 36) <= round_i(39 downto 36) xor sbox_out(7 downto 4) xor round_i(31 downto 28);
  round_o(43 downto 40) <= round_i(43 downto 40) xor sbox_out(11 downto 8) xor round_i(31 downto 28);
  round_o(47 downto 44) <= round_i(47 downto 44) xor sbox_out(15 downto 12) xor round_i(31 downto 28);
  round_o(51 downto 48) <= round_i(51 downto 48) xor sbox_out(19 downto 16) xor round_i(31 downto 28);
  round_o(55 downto 52) <= round_i(55 downto 52) xor sbox_out(23 downto 20) xor round_i(31 downto 28);
  round_o(59 downto 56) <= round_i(59 downto 56) xor sbox_out(27 downto 24) xor round_i(31 downto 28);
  round_o(63 downto 60) <= round_i(63 downto 60)  xor 
                           sbox_out(31 downto 28) xor 
                           round_i(31 downto 28)  xor
                           round_i(27 downto 24)  xor
                           round_i(23 downto 20)  xor
                           round_i(19 downto 16)  xor
                           round_i(15 downto 12)  xor
                           round_i(11 downto 8)   xor
                           round_i(7 downto 4);

end Behavioral;

